Chuyển đến nội dung
Diễn đàn CADViet
  • Thông báo

    • Nguyen Hoanh

      CADViet đã hoàn tất nâng cấp   14/09/2017

      Chào các bạn, CADViet đã hoàn tất việc nâng cấp lên phiên bản mới. Tất cả các chức năng đã hoạt động theo kỳ vọng của ban quản trị. Nếu có vấn đề gì cần phản hồi, các bản post ở đây nhé: Trân trọng, Nguyễn Hoành.
Đăng nhập để thực hiện theo  
Trà Đá

[Yêu cầu] Viết lisp xử lý số liệu từ .txt vào trong cad

Các bài được khuyến nghị

ketxu    2.653

Sau khi pick điểm đặt dòng, nếu đánh sai khoảng cách thì Undo lại


(defun c:itext(/ blk *tH* lstDis lstDisX lstVal fn mLstPnt rl i j p mtext)(vl-load-com)
(setq blk (vla-get-block (vla-get-activelayout(vla-get-activedocument (vlax-get-acad-object)))))
(setq *tH* 1)
(cond 
((setq fn (getfiled "Chon file so lieu" "" "txt" 8))
(defun mtext (str p blk h / obj)
(vla-put-AttachmentPoint (setq obj (vla-addmtext blk (vlax-3d-point p) h str)) 4)
(vla-put-rotation obj (* pi 0.5)) 
)
(defun mLstPnt (p lstDisX lstVal) 
(mapcar '(lambda(y z)(mtext y z blk *tH*))
lstVal
(cons p (mapcar '(lambda(x)(setq p (cons (+ (car p) x) (cdr p)))) lstDisX)) 
)
)

(setq fn (open fn "r") j 0)
(or tmpDis (setq tmpDis 1))
(while (setq rl (read-line fn)) 
(setq  i 1 )
(setq  p (getpoint (strcat "\nDiem dat Text dong thu "(itoa (setq j (1+ j)))" :"))
lstVal (mapcar 'vl-princ-to-string (read (strcat "(" rl ")"))))
(while (< i (1+ (length lstVal))) 
(initget "u")
(setq tmpDis (cond ((getdist (strcat "\nKhoang cach tu cot H" (itoa i) "-> H" (itoa (setq i (1+ i))) " <" (vl-princ-to-string tmpDis) ">:")))(tmpDis)))
(cond  
((or (= tmpDis "u")(= tmpdis "U"))(setq i (- i 2)))
(T (setq lstDisX (cons tmpDis lstDisX))) 
)
) 
(mLstPnt p (reverse lstDisX) lstVal)
(setq lstDis '())
) 
(close fn)
)
)
)

Chia sẻ bài đăng này


Liên kết tới bài đăng
Chia sẻ trên các trang web khác
vantuan18nd    4

Các bác chỉnh sửa giúp em theo cách này với

- mình chỉ cần nhập khoảng cách giữa H1-H2, H2-H3,....

- sau đó tự động phun các cột đó vào CAD ( bỏ qua bước nhập điểm đặt dòng text thứ 1, 2...)

;; free lisp from cadviet.com
;;; this lisp was downloaded from http://www.cadviet.com/forum/index.php?showtopic=64582&pid=202432&st=20entry202432

(defun c:itext(/ blk *tH* lstDis lstDisX lstVal fn mLstPnt rl i j p mtext)(vl-load-com)
(setq blk (vla-get-block (vla-get-activelayout(vla-get-activedocument (vlax-get-acad-object)))))
(setq *tH* 1)
(cond
((setq fn (getfiled "Chon file so lieu" "" "txt" 8))
(defun mtext (str p blk h / obj)
(vla-put-AttachmentPoint (setq obj (vla-addmtext blk (vlax-3d-point p) h str)) 4)
(vla-put-rotation obj (* pi 0.5))
)
(defun mLstPnt (p lstDisX lstVal)
(mapcar '(lambda(y z)(mtext y z blk *tH*))
lstVal
(cons p (mapcar '(lambda(x)(setq p (cons (+ (car p) x) (cdr p)))) lstDisX))
)
)

(setq fn (open fn "r") j 0)
(or tmpDis (setq tmpDis 1))
(while (setq rl (read-line fn))
(setq  i 1 )
(setq  p (getpoint (strcat "\nDiem dat Text dong thu "(itoa (setq j (1+ j)))" :"))
lstVal (mapcar 'vl-princ-to-string (read (strcat "(" rl ")"))))
(while (< i (1+ (length lstVal)))
(initget "u")
(setq tmpDis (cond ((getdist (strcat "\nKhoang cach tu cot H" (itoa i) "-> H" (itoa (setq i (1+ i))) " <" (vl-princ-to-string tmpDis) ">:")))(tmpDis)))
(cond 
((or (= tmpDis "u")(= tmpdis "U"))(setq i (- i 2)))
(T (setq lstDisX (cons tmpDis lstDisX)))
)
)
(mLstPnt p (reverse lstDisX) lstVal)
(setq lstDis '())
)
(close fn)
)
)
)

Chia sẻ bài đăng này


Liên kết tới bài đăng
Chia sẻ trên các trang web khác
phamthanhbinh    3.123

Các bác chỉnh sửa giúp em theo cách này với

- mình chỉ cần nhập khoảng cách giữa H1-H2, H2-H3,....

- sau đó tự động phun các cột đó vào CAD ( bỏ qua bước nhập điểm đặt dòng text thứ 1, 2...)

 

Hề hề hề,

Bỏ qua bước chọn điểm đặt của dòng text thì bạn định phun nó vào đâu??? Vào cái chỗ tè le nào đó cũng được ư??? Và như vậy thì các dòng text này cần cách nhau bao nhiêu????

Hề hề hề, mong bạn nói rõ để nó khỏi tè le bạn nhé....

  • Vote tăng 1

Chia sẻ bài đăng này


Liên kết tới bài đăng
Chia sẻ trên các trang web khác
vantuan18nd    4

Hề hề hề,

Bỏ qua bước chọn điểm đặt của dòng text thì bạn định phun nó vào đâu??? Vào cái chỗ tè le nào đó cũng được ư??? Và như vậy thì các dòng text này cần cách nhau bao nhiêu????

Hề hề hề, mong bạn nói rõ để nó khỏi tè le bạn nhé....

Hè . ý em thế này

Em muốn load cả file ấy vào một điểm đặt bất kỳ.( Như lisp trên thì mình pick chọn điểm chèn thứ nhất, thứ 2, thứ 3...... thứ n. không phù hợp với cái em cần)

em cần sau khi chạy lệnh của lisp thì nó hỏi chọn điểm đặt và kết quả là hiển thị hết luôn hàng và cột.

Đặt vào chỗ tè le nào là do mình chọn, em cũng không quan tâm tới khoảng cách H1-H2, H2-H3.....Hn-1 - Hn.

( ví dụ : có 3 cột và 10 hàng thì sau khi chạy lisp nó hỏi đặt điểm chèn, kết quả hiển thị luôn 3 hàng và 10 cột )

em chẳng biết diễn đạt sao nữa. hì

Chia sẻ bài đăng này


Liên kết tới bài đăng
Chia sẻ trên các trang web khác
phamthanhbinh    3.123

Hè . ý em thế này

Em muốn load cả file ấy vào một điểm đặt bất kỳ.( Như lisp trên thì mình pick chọn điểm chèn thứ nhất, thứ 2, thứ 3...... thứ n. không phù hợp với cái em cần)

em cần sau khi chạy lệnh của lisp thì nó hỏi chọn điểm đặt và kết quả là hiển thị hết luôn hàng và cột.

Đặt vào chỗ tè le nào là do mình chọn, em cũng không quan tâm tới khoảng cách H1-H2, H2-H3.....Hn-1 - Hn.

( ví dụ : có 3 cột và 10 hàng thì sau khi chạy lisp nó hỏi đặt điểm chèn, kết quả hiển thị luôn 3 hàng và 10 cột )

em chẳng biết diễn đạt sao nữa. hì

Hề hề hề,

Vậy sao bạn không xài copy clipboard trong xls rồi paste sang CAD một phát là xong???? Lisp liếc làm chi cho nó thêm phần ..... bác học vậy???

Chia sẻ bài đăng này


Liên kết tới bài đăng
Chia sẻ trên các trang web khác

Thực sự như bạn yêu cầu thì không ai giúp được đâu. Nếu như bạn nói đặt 1 phát ăn luôn thì cái bản vẽ của bạn phải có tổ chức đàng hoàng. Như kiếu: khoảng cách các hàng là bao nhiêu? KC các cột là bao nhiêu? thì phát ăn ngay chắc được (Như kiểu NOVA)

Chia sẻ bài đăng này


Liên kết tới bài đăng
Chia sẻ trên các trang web khác

Tạo một tài khoản hoặc đăng nhập để nhận xét

Bạn cần phải là một thành viên để lại một bình luận

Tạo tài khoản

Đăng ký một tài khoản mới trong cộng đồng của chúng tôi. Điều đó dễ mà.

Đăng ký tài khoản mới

Đăng nhập

Bạn có sẵn sàng để tạo một tài khoản ? Đăng nhập tại đây.

Đăng nhập ngay

Đăng nhập để thực hiện theo  

×